<?php 
class WPUEF_CheckoutPage
{
	public function __construct()
	{
		add_action('wp_head', array( &$this, 'add_js_scripts'));
	}
	public function add_js_scripts()
	{
		if(!is_admin() && function_exists('is_checkout') &&  @is_checkout())
		{
			$woocommerce_enable_guest_checkout = get_option( 'woocommerce_enable_guest_checkout' );
			$woocommerce_enable_guest_checkout = isset($woocommerce_enable_guest_checkout) ? $woocommerce_enable_guest_checkout : 'no';
			
			wp_register_script('wpuef-checkout-page', WPUEF_PLUGIN_PATH.'/js/wpuef-frontend-checkout-page.js', array('jquery'));
				$js_options = array(
					'is_logged' => is_user_logged_in() || $woocommerce_enable_guest_checkout == 'no' ? 'true' : 'false',
			);	
			wp_localize_script('wpuef-checkout-page', 'wpuef_checkout', $js_options );
			wp_enqueue_script('wpuef-checkout-page', WPUEF_PLUGIN_PATH.'/js/wpuef-frontend-checkout-page.js', array('jquery'));
			
		}
	}
}
?>